Panda3D

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | List of all members
AnimChannelMatrixFixed Class Reference

A specialization on AnimChannel to add all the special matrix component operations. More...

`#include "animChannelMatrixFixed.h"`

Inheritance diagram for AnimChannelMatrixFixed:

## Public Member Functions
| AnimChannelMatrixFixed (const std::string &name, const LVecBase3 &pos, const LVecBase3 &hpr, const LVecBase3 &scale)
virtual TypeHandle | force_init_type ()
virtual void | get_hpr (int frame, LVecBase3 &hpr)
| Returns the h, p, and r components associated with the current frame.
virtual void | get_pos (int frame, LVecBase3 &pos)
| Returns the x, y, and z translation components associated with the current frame.
virtual void | get_quat (int frame, LQuaternion &quat)
| Returns the rotation component associated with the current frame, expressed as a quaternion.
virtual void | get_scale (int frame, LVecBase3 &scale)
| Gets the scale value at the indicated frame.
virtual void | get_shear (int frame, LVecBase3 &shear)
| Returns the a, b, and c shear components associated with the current frame.
virtual TypeHandle | get_type () const
virtual void | get_value (int frame, LMatrix4 &value)
virtual void | get_value_no_scale_shear (int frame, LMatrix4 &value)
| Gets the value of the channel at the indicated frame, without any scale or shear information.
virtual bool | has_changed (int last_frame, double last_frac, int this_frame, double this_frac)
| Returns true if the value has changed since the last call to has_changed().
virtual void | output (std::ostream &out) const
| Writes a one-line description of the group.
virtual void | write_datagram (BamWriter *manager, Datagram &dg)
| Writes the contents of this object to the datagram for shipping out to a Bam file.
Public Member Functions inherited from AnimChannel< ACMatrixSwitchType >
| AnimChannel (AnimGroup *parent, const std::string &name)
| This is the normal constructor, which automatically places the AnimChannel in the previously-created hierarchy.
| AnimChannel (AnimGroup *parent, const std::string &name)
| This is the normal constructor, which automatically places the AnimChannel in the previously-created hierarchy.
virtual void | get_value_no_scale_shear (int frame, ValueType &value)
| Returns the value associated with the current frame, with no scale or share components.
virtual TypeHandle | get_value_type () const
| Returns the TypeHandle associated with the ValueType we return.
virtual TypeHandle | get_value_type () const
| Returns the TypeHandle associated with the ValueType we return.
Public Member Functions inherited from AnimChannelBase
| AnimChannelBase (AnimGroup *parent, const std::string &name)
| This is the normal constructor, which automatically places the AnimChannel in the previously-created hierarchy.
Public Member Functions inherited from AnimGroup
| AnimGroup (AnimGroup *parent, const std::string &name)
| Creates the AnimGroup, and adds it to the indicated parent.
virtual int | complete_pointers (TypedWritable **p_list, BamReader *manager)
| Takes in a vector of pointes to TypedWritable objects that correspond to all the requests for pointers that this object made to BamReader.
AnimGroup * | find_child (const std::string &name) const
| Returns the first descendant found with the indicated name, or NULL if no such descendant exists.
AnimGroup * | get_child (int n) const
AnimGroup * | get_child_named (const std::string &name) const
| Returns the first child found with the indicated name, or NULL if no such child exists.
int | get_num_children () const
void | sort_descendants ()
| Sorts the children nodes at each level of the hierarchy into alphabetical order.
virtual void | write (std::ostream &out, int indent_level) const
| Writes a brief description of the group and all of its descendants.
Public Member Functions inherited from TypedWritableReferenceCount
| TypedWritableReferenceCount (const TypedWritableReferenceCount &copy)
virtual ReferenceCount * | as_reference_count ()
| Returns the pointer cast to a ReferenceCount pointer, if it is in fact of that type.
void | operator= (const TypedWritableReferenceCount &copy)
Public Member Functions inherited from TypedWritable
| TypedWritable (const TypedWritable &copy)
vector_uchar | encode_to_bam_stream () const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and returns that data as a bytes object.
bool | encode_to_bam_stream (vector_uchar &data, BamWriter *writer=nullptr) const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and stores that data in the indicated string.
virtual void | finalize (BamReader *manager)
| Called by the BamReader to perform any final actions needed for setting up the object after all objects have been read and all pointers have been completed.
UpdateSeq | get_bam_modified () const
| Returns the current bam_modified counter.
void | mark_bam_modified ()
| Increments the bam_modified counter, so that this object will be invalidated and retransmitted on any open bam streams.
void | operator= (const TypedWritable &copy)
virtual bool | require_fully_complete () const
| Some objects require all of their nested pointers to have been completed before the objects themselves can be completed.
virtual void | update_bam_nested (BamWriter *manager)
| Called by the BamWriter when this object has not itself been modified recently, but it should check its nested objects for updates.
Public Member Functions inherited from TypedObject
| TypedObject (const TypedObject &copy)=default
TypedObject * | as_typed_object ()
| Returns the object, upcast (if necessary) to a TypedObject pointer.
const TypedObject * | as_typed_object () const
| Returns the object, upcast (if necessary) to a TypedObject pointer.
int | get_best_parent_from_Set (const std::set< int > &) const
int | get_type_index () const
| Returns the internal index number associated with this object's TypeHandle, a unique number for each different type.
bool | is_exact_type (TypeHandle handle) const
| Returns true if the current object is the indicated type exactly.
bool | is_of_type (TypeHandle handle) const
| Returns true if the current object is or derives from the indicated type.
TypedObject & | operator= (const TypedObject &copy)=default
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object.
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise.
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack.
void | ref () const
| Explicitly increments the reference count.
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero.
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus.
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus.
virtual bool | unref () const
| Explicitly decrements the reference count.
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one.
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object.
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object.
Public Member Functions inherited from Namable
| Namable (const std::string &initial_name="")
void | clear_name ()
| Resets the Namable's name to empty.
const std::string & | get_name () const
bool | has_name () const
| Returns true if the Namable has a nonempty name set, false if the name is empty.
void | output (std::ostream &out) const
| Outputs the Namable.
void | set_name (const std::string &name)

## Static Public Member Functions
static TypeHandle | get_class_type ()
static void | init_type ()
static void | register_with_read_factory ()
| Tells the BamReader how to create objects of type AnimChannelMatrixFixed.
Static Public Member Functions inherited from AnimChannel< ACMatrixSwitchType >
static TypeHandle | get_class_type ()
static TypeHandle | get_class_type ()
static void | init_type ()
static void | init_type ()
Static Public Member Functions inherited from AnimChannelBase
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from AnimGroup
static TypeHandle | get_class_type ()
static void | init_type ()
static TypedWritable * | make_AnimGroup (const FactoryParams &params)
| Factory method to generate a AnimGroup object.
static void | register_with_read_factory ()
| Factory method to generate a AnimGroup object.
Static Public Member Functions inherited from TypedWritableReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
static | PT (TypedWritableReferenceCount) decode_from_bam_stream(vector_uchar data
Static Public Member Functions inherited from TypedWritable
static bool | decode_raw_from_bam_stream (TypedWritable *&ptr, ReferenceCount *&ref_ptr, vector_uchar data, BamReader *reader=nullptr)
| Reads the bytes created by a previous call to encode_to_bam_stream(), and extracts the single object on those bytes.
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedObject
static TypeHandle | get_class_type ()
static void | init_type ()
| This function is declared non-inline to work around a compiler bug in g++ 2.96.
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from Namable
static TypeHandle | get_class_type ()
static void | init_type ()

## Additional Inherited Members
Public Types inherited from AnimChannel< ACMatrixSwitchType >
typedef ACMatrixSwitchType::ValueType | ValueType
Public Attributes inherited from AnimGroup
| get_child
| Returns the nth child of the group.
| get_num_children
| Returns the number of child nodes of the group.
Public Attributes inherited from TypedWritableReferenceCount
static BamReader * | reader = nullptr)
Public Attributes inherited from TypedObject
| get_type
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count.
Public Attributes inherited from Namable
| get_name
| set_name
Static Public Attributes inherited from TypedWritable
static TypedWritable *const | Null = nullptr

## Detailed Description

A specialization on AnimChannel to add all the special matrix component operations.

Definition at line 26 of file animChannelMatrixFixed.h.

## Constructor & Destructor Documentation

## ◆ AnimChannelMatrixFixed()

AnimChannelMatrixFixed::AnimChannelMatrixFixed | ( | const std::string & | name,
|  | const LVecBase3 & | pos,
|  | const LVecBase3 & | hpr,
|  | const LVecBase3 & | scale )

Definition at line 36 of file animChannelMatrixFixed.cxx.

## Member Function Documentation

## ◆ force_init_type()

virtual TypeHandle AnimChannelMatrixFixed::force_init_type | ( |  | ) |
| inline virtual

Reimplemented from AnimChannel< ACMatrixSwitchType >.

Definition at line 60 of file animChannelMatrixFixed.h.

## ◆ get_class_type()

static TypeHandle AnimChannelMatrixFixed::get_class_type | ( |  | ) |
| inline static

Definition at line 61 of file animChannelMatrixFixed.h.

## ◆ get_hpr()

void AnimChannelMatrixFixed::get_hpr | ( | int | frame,
|  | LVecBase3 & | hpr )
| virtual

Returns the h, p, and r components associated with the current frame.

As above, this only makes sense for a matrix-type channel.

Reimplemented from AnimChannel< ACMatrixSwitchType >.

Definition at line 82 of file animChannelMatrixFixed.cxx.

## ◆ get_pos()

void AnimChannelMatrixFixed::get_pos | ( | int | frame,
|  | LVecBase3 & | pos )
| virtual

Returns the x, y, and z translation components associated with the current frame.

As above, this only makes sense for a matrix-type channel.

Reimplemented from AnimChannel< ACMatrixSwitchType >.

Definition at line 101 of file animChannelMatrixFixed.cxx.

## ◆ get_quat()

void AnimChannelMatrixFixed::get_quat | ( | int | frame,
|  | LQuaternion & | quat )
| virtual

Returns the rotation component associated with the current frame, expressed as a quaternion.

As above, this only makes sense for a matrix-type channel.

Reimplemented from AnimChannel< ACMatrixSwitchType >.

Definition at line 92 of file animChannelMatrixFixed.cxx.

## ◆ get_scale()

void AnimChannelMatrixFixed::get_scale | ( | int | frame,
|  | LVecBase3 & | scale )
| virtual

Gets the scale value at the indicated frame.

Reimplemented from AnimChannel< ACMatrixSwitchType >.

Definition at line 73 of file animChannelMatrixFixed.cxx.

## ◆ get_shear()

void AnimChannelMatrixFixed::get_shear | ( | int | frame,
|  | LVecBase3 & | shear )
| virtual

Returns the a, b, and c shear components associated with the current frame.

As above, this only makes sense for a matrix-type channel.

Reimplemented from AnimChannel< ACMatrixSwitchType >.

Definition at line 110 of file animChannelMatrixFixed.cxx.

## ◆ get_type()

virtual TypeHandle AnimChannelMatrixFixed::get_type | ( |  | ) | const
| inline virtual

Reimplemented from AnimChannel< ACMatrixSwitchType >.

Definition at line 57 of file animChannelMatrixFixed.h.

## ◆ get_value()

void AnimChannelMatrixFixed::get_value | ( | int | frame,
|  | LMatrix4 & | value )
| virtual

Implements AnimChannel< ACMatrixSwitchType >.

Definition at line 55 of file animChannelMatrixFixed.cxx.

## ◆ get_value_no_scale_shear()

void AnimChannelMatrixFixed::get_value_no_scale_shear | ( | int | frame,
|  | LMatrix4 & | value )
| virtual

Gets the value of the channel at the indicated frame, without any scale or shear information.

Reimplemented from AnimChannel< ACMatrixSwitchType >.

Definition at line 64 of file animChannelMatrixFixed.cxx.

## ◆ has_changed()

bool AnimChannelMatrixFixed::has_changed | ( | int | last_frame,
|  | double | last_frac,
|  | int | this_frame,
|  | double | this_frac )
| virtual

Returns true if the value has changed since the last call to has_changed().

last_frame is the frame number of the last call; this_frame is the current frame number. last_frac and this_frac are the fractional steps into those frames, which will be 0.0 unless we are running in frame_blend mode.

Reimplemented from AnimChannelBase.

Definition at line 46 of file animChannelMatrixFixed.cxx.

## ◆ init_type()

static void AnimChannelMatrixFixed::init_type | ( |  | ) |
| inline static

Definition at line 64 of file animChannelMatrixFixed.h.

## ◆ output()

void AnimChannelMatrixFixed::output | ( | std::ostream & | out | ) | const
| virtual

Writes a one-line description of the group.

Reimplemented from AnimGroup.

Definition at line 118 of file animChannelMatrixFixed.cxx.

References AnimGroup::output().

## ◆ register_with_read_factory()

void AnimChannelMatrixFixed::register_with_read_factory | ( |  | ) |
| static

Tells the BamReader how to create objects of type AnimChannelMatrixFixed.

Definition at line 127 of file animChannelMatrixFixed.cxx.

References BamReader::get_factory(), and Factory< Type >::register_factory().

## ◆ write_datagram()

void AnimChannelMatrixFixed::write_datagram | ( | BamWriter * | manager,
|  | Datagram & | dg )
| virtual

Writes the contents of this object to the datagram for shipping out to a Bam file.

Reimplemented from AnimChannelBase.

Definition at line 136 of file animChannelMatrixFixed.cxx.

References AnimChannelBase::write_datagram().

The documentation for this class was generated from the following files:

- panda/src/chan/animChannelMatrixFixed.h
- panda/src/chan/animChannelMatrixFixed.cxx